
darktable - Bug #10704

green atifacts with denoise profiled

11/08/2015 04:25 PM - Pascal Obry

Status: Fixed Start date: 11/08/2015

Priority: Medium Due date:  

Assignee:  % Done: 100%

Category: Darkroom Estimated time: 0.00 hour

Target version:    

Affected Version: git development version bitness: 64-bit

System: all hardware

architecture:

amd64/x86

Description

Attached is a CR2 with the corresponding .xmp.

The image has some noise. When a wavelet denoise profile is activated there is lot of green appearing on the fur of the gorilla.

Don't think this is expected. Looks like a bug to me.

It has been reported by a friend using 1.6.8 and I have been able to reproduce with the Git master version.

Note that I have deactivate the 7D denoise data and recompiled dt to use the generic profile and I have the same issue. So it does

not look like an issue with the specific profile for the 7D.

Associated revisions

Revision 9e366113 - 03/11/2019 08:43 AM - rawfiner -

denoiseprofile: fix anscombe transform

processed_maximum does NOT always holds the white balance multipliers.

Sometimes, all 3 processed_maximum values are equal to the higher multiplier.

We want to have an anscombe transform adaptive, that takes white balance into account.

Indeed, a white balance coeff >1 on blue means that the blue is affected by the noise

like if the shot was taken at an higher ISO value that the current one.

The code now take into account such differences that occur between the channels.

Considering the "2.0" coeff that was here in wavelets mode:

the noise distribution is independent of the number of pixels, thus we should not

have such coeff, even if there are 2 times more green pixels than red or blue on

a bayer matrix.

Fixes #10704

History

#1 - 12/17/2015 12:02 AM - Joe Giampaoli

- File Screenshot - 12162015 - 03_56_08 PM.png added
I have this very same issue with self made profiles on my Canon SX510. I noticed it at first on the fur of a Squirrel. I just thought maybe it's my profile,

not perfect. My profiles denoise very well actually, but now that I saw this bug report it got me thinking. One small work around is that if I choose

"linearRec 709" on the input color profile these green artifacts seem to diminish a bit, then I can increase the saturation and colors because that input

profile is very flat.

And yes, this only happens with wavelets denoising.

Attaching screenshot of what I see. Just above the eye of the squirrel and on the head you can see that greenish tint artifacts.

Thanks!

#2 - 12/18/2015 09:49 PM - Pedro Côrte-Real

Do you happen to have opencl enabled? Does it change if you disable it?

#3 - 12/19/2015 12:39 AM - Pascal Obry

No, I have the same result with and without OpenCL.

#4 - 12/22/2015 11:31 PM - Joe Giampaoli

- File Screenshot - 12222015 - 03_30_49 PM.png added

Pedro Côrte-Real wrote:

Do you happen to have opencl enabled? Does it change if you disable it?

 

In my case it seems it's enabled but I can't disable it. The check-mark is like greyed out but active. I believe I have openCL installed right in Debian,

but maybe the openCL packages are too old?

#5 - 12/23/2015 10:56 AM - Pascal Obry

If it's gray out and ticked it means that it has been activated at some point but it is not activated now. Meaning that you're missing some OpenCL

libraries now.

#6 - 12/23/2015 11:09 AM - Joe Giampaoli

Pascal Obry wrote:

If it's gray out and ticked it means that it has been activated at some point but it is not activated now. Meaning that you're missing some OpenCL

libraries now.

 

OK, I see, well I tried starting DT with -d opencl -d perf and got the following:

[opencl_init] opencl related configuration options:

[opencl_init] 

[opencl_init] opencl: 1

[opencl_init] opencl_library: ''
[opencl_init] opencl_memory_requirement: 768

[opencl_init] opencl_memory_headroom: 300

[opencl_init] opencl_device_priority: '*/!0,*/*/*'

[opencl_init] opencl_size_roundup: 16

[opencl_init] opencl_async_pixelpipe: 0

[opencl_init] opencl_synch_cache: 0

[opencl_init] opencl_number_event_handles: 25

[opencl_init] opencl_micro_nap: 1000

[opencl_init] opencl_use_pinned_memory: 0

[opencl_init] opencl_use_cpu_devices: 0

[opencl_init] opencl_avoid_atomics: 0

[opencl_init] opencl_omit_whitebalance: 0

[opencl_init] 

[opencl_init] found opencl runtime library 'libOpenCL'

[opencl_init] opencl library 'libOpenCL' found on your system and loaded

[opencl_init] found 2 platforms

[opencl_init] found 2 devices

[opencl_init] device 0 `GeForce 210' doesn't have sm_20 support.

[opencl_init] discarding device 0 `GeForce 210' due to insufficient global memory (511MB).

[opencl_init] discarding CPU device 1 `AMD Athlon(tm) II X3 450 Processor'.

[opencl_init] no suitable devices found.

[opencl_init] FINALLY: opencl is NOT AVAILABLE on this system.

[opencl_init] initial status of opencl enabled flag is OFF.

 

It does seem to work with 3d rendering program I use, "luxrender" I used to get an error about not finding openCL, when I installed the Debian

libraries it stopped showing that error but really have not tested fully render times in it now that I installed it.

Doesn't really matter, it would be nice to have that extra speed during export but I guess I can live without it, I think it has to do with my card's sm_20

support, I'll figure it out, I don't want to drive this report to another direction....

Thanks anyway, I appreciate it!

#7 - 12/23/2015 11:58 PM - Pascal Obry

- Status changed from New to Closed: won't fix

Ok, closing then. The card has not enough memory.
#8 - 12/24/2015 12:05 AM - Joe Giampaoli

Pascal Obry wrote:

Ok, closing then. The card has not enough memory.

 

Hmmm, does this memory limit in openCL affect the issue with the green artifacts then?

#9 - 12/24/2015 12:07 AM - Pedro Côrte-Real

- Status changed from Closed: won't fix to New

The bug isn't about an opencl issue, it's about green artifacts with denoise. The fact that opencl doesn't work isn't really a resolution, it just means that

if there's a bug it's in the CPU code path or possibly in both.

#10 - 12/24/2015 12:09 AM - Pascal Obry

Sorry, my mistake I should not have closed this one :) This has nothing to do with OpenCL indeed. The confusion is that the OpenCL issue has been

raised here but it is a completely different issue.

#11 - 12/24/2015 12:12 AM - Joe Giampaoli

AH! That's good to know! I was a bit worried there for a second! :)

Thanks!

#12 - 12/31/2015 01:10 PM - Pedro Côrte-Real

- Affected Version changed from 1.6.8 to git development version

- File ProfiledDenoiseOff.png added

- File ProfiledDenoiseOn.png added

- File DSC01698.ARW added

- File DSC01698.ARW.xmp added

- Status changed from New to Confirmed

- % Done changed from 0 to 10

- System changed from Debian to all

I've reproduced this with one of my images. This time it's the grey coat of a donkey :) It seems easy to trigger in a very visible way by using wavelet

mode and HSV color blending which is the suggested way of eliminating chroma noise (and usually works quite well).

#13 - 12/31/2015 01:52 PM - Joe Giampaoli

- File CRW_0815.DNG added

- File CRW_0815.DNG.xmp added

By looking at our previous examples, it seems to me that when there's more green value in an image these artifacts become more noticeable. All

previous shots have green grass in the background. Here's another test with a dog in an interior of a pharmacy, you can see that the artifacts aren't

as exaggerated as the previous ones, and this one is shot at a reasonably high ISO. Attaching both RAW and sidecard.
#14 - 12/31/2015 09:00 PM - Pedro Côrte-Real

- File ProfiledDenoiseOn2.png added

- File ProfiledDenoiseOff2.png added

- Subject changed from green atifacts with denoise profile on Canon 7D to green atifacts with denoise profiled

Found a pretty extreme case when testing out a Nikon D810 ISO 12800 file. It's almost as if the green channel noise isn't being eliminated or is even

being enhanced.

#15 - 12/31/2015 11:47 PM - Joe Giampaoli

Pedro Côrte-Real wrote:

Found a pretty extreme case when testing out a Nikon D810 ISO 12800 file. It's almost as if the green channel noise isn't being eliminated or is

even being enhanced.

 

Pedro, may I try something with your original RAW?

#16 - 01/01/2016 02:23 AM - Pedro Côrte-Real

Joe Giampaoli wrote:

Pedro, may I try something with your original RAW?

 

Sure. It's too big to attach here but here's a link:

http://scratch.corujas.net/D81_5386.NEF

#17 - 01/01/2016 03:04 AM - Joe Giampaoli

- File Screenshot - 12312015 - 06_58_02 PM.png added

- File D81_5386.NEF.xmp added

Thanks Pedro, just wanted to compare with my RAW's. Nice shot BTW.

This is what I get when purging the history stack to original and just basic corrections. Using linearRec709 as input color profile does seem to help a

little, even adding extra saturation later, but not 100% effective. This is pretty much how I have been doing it since I saw this green artifacts, as I

mentioned before, I thought my denoising profiles or using a CHDK RAW made file had something to do with it. I have also tried exporting to 16bit tiff

with no denoising at all and then try to apply the denoising to the tiff but unfortunately it's not as effective as doing it directly on the RAW. I'll attach my

xmp version of your RAW if you want to see pretty much what I do. Later I apply something like a low-pass filter with extra saturation in multiply mode

to bring out those colors...

Cheers
#18 - 01/28/2016 02:10 PM - Maximilian Trescher

I experienced the same issues with shots from a Canon 60D.

Curiously there are no green artifacts when I use the equalizer module and apply some chroma denoise.

(I can provide the Raw and xmp files if needed, right now I don"t have access to them).

Cheers

Max

#19 - 04/27/2016 11:00 PM - Johannes Hanika

- File img_0001_02.jpg added

here's my jpg of the green artifact wall. it is really touchy at these noise levels.. using a second instance of profiled denoising with lightness doesn't

work, but using HSV lightness performs a lot better. i think maybe the numbers are so small that the colour space transforms become unstable? given

this interesting variation in outcome based on the blend mode maybe the culprit is blending and not denoising?

#20 - 10/17/2016 12:04 PM - Pascal Obry

- % Done changed from 10 to 100

- Status changed from Confirmed to Fixed

I think this issue is fixed. I suppose this is due to Roman's work on the low level sensor data fixes done recently. Can someone confirm this is also

fixed?

I cannot reproduce with attached DSC01698.ARW nor with my original sample IMG_4365.CR2.

#21 - 10/17/2016 12:33 PM - Joe Giampaoli

Hmmmm, I still get green artifacts in stable 2.0.6

Are we supposed to try with development branch?

Thanks!

#22 - 10/17/2016 12:53 PM - Pascal Obry

No you are not supposed to test the dev branch if you are not a developer and not ready to have some issues from time to time.

But yes I was talking about testing the dev version has the fixes have been integrated there only.

#23 - 10/17/2016 02:42 PM - Roman Lebedev

Pascal Obry wrote:

I think this issue is fixed. I suppose this is due to Roman's work on the low level sensor data fixes done recently.
Hm?

#24 - 10/17/2016 03:54 PM - Pascal Obry

I think it could be due to the fix on the white level you've done in many places? Couldn't this be it?

#25 - 10/17/2016 04:15 PM - Roman Lebedev

- % Done changed from 100 to 10

- Status changed from Fixed to Confirmed

Not really, those white level fixes mostly only touch nikon.

#26 - 10/17/2016 11:21 PM - Pascal Obry

Ok, yet this is fixed on my side. A good news... But then we really don't know at this point what has fixed this!

#27 - 10/17/2016 11:22 PM - Joe Giampaoli

Here's a screenshot from today, same DNG with the embedded color profile of the file, maybe it's a bit less than my older screenshot, but if you look

carefully, you will see some greenish artifacts on the head and part of the tail. This is now in latest 2.0.6.

The only de-noising at the moment on this sample is the one expanded on the screenshot which is wavelet on the color channel, HSV color gives me

pretty much same results, also you will see that I purged out any automatic applied curves from the start on my history stack, I always do that...

Thanks!

#28 - 10/17/2016 11:24 PM - Joe Giampaoli

- File Screenshot - 10172016 - 03_15_17 PM.png added

Hmmm, didn't upload screenshot? Let's try again...

#29 - 10/17/2016 11:26 PM - Pascal Obry

Which is expected as the fix is only in the development version not yet released.

#30 - 10/17/2016 11:28 PM - Joe Giampaoli

Oh! OK! That's good news!

If you want my DNG just to test let me know.

Will this fix be released in next stable then?

This is really great!

Thanks!

#31 - 10/17/2016 11:29 PM - Pascal Obry

Yes please make available the DNG and the .xmp I'll double check with my version. Thanks.
#32 - 10/17/2016 11:39 PM - Joe Giampaoli

- File CRW_1724.DNG.xmp added

- File CRW_1724.DNG added

OK, here are both, since it's a CHDK DNG it shouldn't be to big to upload here, I hope...

The XMP is just a basic edit to make those artifacts appear, not much processing but basic corrections.

Thanks again!

#33 - 10/18/2016 03:25 PM - Pascal Obry

- File Capture d_écran de 2016-10-18 14-23-47.png added

With the development version.

#34 - 10/18/2016 11:22 PM - Joe Giampaoli

- File Screenshot - 10182016 - 03_14_08 PM.png added

OK, yes, it's a bit better. I can still see a little bit of it but not as bad as before with the embedded color profile. Still if I change the input color profile it

always gives me better results here on latest stable, I usually use linear rec 709 or linear rec 2020, I think I will get better results now with these

profiles and the results you get.

Here's a sample of what I get with linear rec 709 and saturation bumped to 100% so it's almost similar to your screenshot, but like I said, yours is with

the embedded profile, which in my case always gives me a lot more of those artifacts.

So to keep it simple, not precisely fixed I think, but better!

Thanks for trying my RAW with your version

#35 - 01/01/2019 01:35 PM - Björn Sonnenschein

This issue still persists for me.

In the mailing list, Rawfiner mentioned the following:

https://www.mail-archive.com/darktable-dev@lists.darktable.org/msg03734.html

Is this related?

#36 - 03/11/2019 06:41 PM - rawfiner -

- Status changed from Confirmed to Fixed

- % Done changed from 10 to 100

Applied in changeset darktable|9e366113e3ecd701cc0e39983b55f053e1a3d40c.

Files

IMG_4365.CR2.xmp 3.2 KB 11/08/2015 Pascal Obry
IMG_4365.CR2 26.7 MB 11/08/2015 Pascal Obry

Screenshot - 12162015 - 03_56_08 PM.png 1.4 MB 12/16/2015 Joe Giampaoli

Screenshot - 12222015 - 03_30_49 PM.png 36.8 KB 12/22/2015 Joe Giampaoli

ProfiledDenoiseOff.png 1.45 MB 12/31/2015 Pedro Côrte-Real

ProfiledDenoiseOn.png 1.41 MB 12/31/2015 Pedro Côrte-Real

DSC01698.ARW 20.3 MB 12/31/2015 Pedro Côrte-Real

DSC01698.ARW.xmp 8.77 KB 12/31/2015 Pedro Côrte-Real

CRW_0815.DNG 18.3 MB 12/31/2015 Joe Giampaoli

CRW_0815.DNG.xmp 3.31 KB 12/31/2015 Joe Giampaoli

ProfiledDenoiseOff2.png 551 KB 12/31/2015 Pedro Côrte-Real

ProfiledDenoiseOn2.png 561 KB 12/31/2015 Pedro Côrte-Real

D81_5386.NEF.xmp 2.49 KB 01/01/2016 Joe Giampaoli

Screenshot - 12312015 - 06_58_02 PM.png 542 KB 01/01/2016 Joe Giampaoli

img_0001_02.jpg 15.2 MB 04/27/2016 Johannes Hanika

Screenshot - 10172016 - 03_15_17 PM.png 1.46 MB 10/17/2016 Joe Giampaoli

CRW_1724.DNG.xmp 4.35 KB 10/17/2016 Joe Giampaoli

CRW_1724.DNG 18.3 MB 10/17/2016 Joe Giampaoli

Capture d_écran de 2016-10-18 14-23-47.png 1.62 MB 10/18/2016 Pascal Obry

Screenshot - 10182016 - 03_14_08 PM.png 1.48 MB 10/18/2016 Joe Giampaoli
